var playfield = document.getElementById('playfield');
var turret = new Turret();
var alienShip = new AlienShip();
var missile = null;

var drawPlayField = function(context) {
  context.clearRect(0, 0, playfield.width, playfield.height);
  context.beginPath();    
}
    
var drawTurret = function(context, center, turret) {
  context.fillStyle = 'gray';
  context.fillRect(
    center.x - 15, playfield.height - 15, turret.base, turret.base);  

  context.fillStyle = 'green';
  context.fillRect(
    center.x - 5, playfield.height - 25, turret.height, turret.height);    
}

var drawAlienShip = function(context, ship) {
  context.save();
  context.scale(0.5, 0.25);
  context.lineWidth = 10;
  context.strokeStyle = 'red';
  context.fillStyle = 'red';

  context.arc(2 * ship.x, 4 * ship.y, ship.radius, 0, 2 * Math.PI, false);
  context.fill();
  context.restore();
}

var drawMissile = function(context, missile) {
  context.save();
  context.lineWidth = 10;
  context.strokeStyle = 'brown';
  context.fillStyle = 'brown';
  context.fillRect(missile.x - 2, missile.y - 10, 4, 15);
  context.restore();
  context.save();
  context.closePath();
  context.beginPath();
  context.fillStyle = 'red';
  context.arc(missile.x, missile.y - 10, 2, 0, Math.PI, true);
  context.fill();
  context.restore();  
}

var fire = function() {
  missile = new Missile(playfield.width / 2, playfield.height);
}

var runGame = function() {
  try {
    var context = playfield.getContext('2d');
    var center = {x: playfield.width/2, y: playfield.height/2};

    drawPlayField(context);

    drawTurret(context, center, turret);
    drawAlienShip(context, alienShip);

    if(missile != null) {
      drawMissile(context, missile);
    } 

    if(alienShip.move() == false) {
      alienShip = new AlienShip();
    } 

    if(missile != null && missile.move() == false) {
      missile = null;
    }
    
    if(missile != null && alienShip.isHit(missile)) {
      alienShip = new AlienShip();
    } 
  } catch(ex) {
    console.log(ex);
  }
  
  setTimeout(runGame, 10);
}

document.addEventListener('mouseup', fire);
playfield.addEventListener('touchend', fire, false);      
runGame();